/*
  Windows 2000 XP API Wrapper Pack
  Copyright (C) 2008 OldCigarette

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

typedef unsigned int BOOL;

BOOL CPUID_Available() {
	__asm {
		pushfd
		pop eax
		mov edx, eax
		xor eax, 00200000h
		push eax
		popfd
		pushfd
		pop eax
		cmp eax, edx
		mov eax, 0
		jz NO_CPUID
		mov eax, 1
	NO_CPUID:
	}
}

BOOL SYSCALL_Available() {
	__asm {
		push ebx
		mov eax, 80000001h
		cpuid
		test edx, 800h
		mov eax, 0
		jz NO_SYSCALL
		mov eax, 1
	NO_SYSCALL:
		pop ebx
	}
}

BOOL SYSENTER_Available() {
	__asm {
		push ebx
		mov eax, 1
		cpuid
		test edx, 800h
		mov eax, 0
		jz NO_SYSENTER
		mov eax, 1
	NO_SYSENTER:
		pop ebx
	}
}