#pragma once

/*
  Windows 2000 XP API Wrapper Pack
  Copyright (C) 2008 OldCigarette

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

__inline LARGE_INTEGER  __readmsr(int reg) {
	LARGE_INTEGER i;
	__asm {
		mov ecx, reg
		rdmsr
		mov i.LowPart, eax
		mov i.HighPart, edx
	}
	return i;
};

__inline void __writemsr(unsigned long reg, LARGE_INTEGER val) {
	__asm {
		mov ecx, reg
		mov eax, val.LowPart
		mov edx, val.HighPart
		wrmsr
	}
};

#pragma pack(push, 1)
typedef struct tagGDTR {
	WORD limit;
	DWORD base;
} GDTR, *PGDTR;

typedef GDTR IDTR, *PIDTR;

typedef struct tagINT_GATE_DESC {
	WORD addrlo;
	WORD seg;
	BYTE reserv : 5;
	BYTE zerome : 3;
	BYTE type   : 5;
	BYTE dpl    : 2;
	BYTE pres   : 1;
	WORD addrhi;
} INT_GATE_DESC, *PINT_GATE_DESC;

typedef struct tagSTAR {
	DWORD eip;
	WORD  call_cs;
	WORD  ret_cs;
} STAR, *PSTAR;
#pragma pack(pop)

enum GDT_INDEX {
	KGDT_NULL,
	KGDT_R0_CODE,
	KGDT_R0_DATA,
	KGDT_R3_CODE,
	KGDT_R3_DATA
};

enum DESC_TBL {
	GLOBAL_DESC_TBL,
	LOCAL_DESC_TBL
};

enum PRIVLEDGE_LEVEL {
	RING_0, RING_1, RING_2, RING_3
};

#define SEG_SELECTOR(index, table, pl) (((index)<<3)|((table)<<2)|(pl))
