#include <windows.h>
#include <stdio.h>

void ReplaceNTDLLInterrupts() {
	HMODULE ModuleBase;
	WORD NumSections;
	PIMAGE_DOS_HEADER dos;
	PIMAGE_NT_HEADERS nt;
	PIMAGE_SECTION_HEADER sections;
	DWORD i, j, oldProtect;
	static char sig[] = { 0x8D, 0x54, 0x24, 0x04, 0xCD, 0x2E };
	
	ModuleBase = GetModuleHandle("ntdll.dll");
	dos =(PIMAGE_DOS_HEADER) ModuleBase;
    nt  =(PIMAGE_NT_HEADERS)((ULONG) ModuleBase + dos->e_lfanew);
	NumSections = nt->FileHeader.NumberOfSections;
	sections = (PIMAGE_SECTION_HEADER)((PBYTE)nt + sizeof(IMAGE_NT_HEADERS));
	for(i = 0; i < NumSections; i++) {
		if(strncmp(".text", sections[i].Name, 4) == 0) {
			printf("NTDLL .text @ 0x%08X size = 0x%08X\n", (DWORD)ModuleBase + sections[i].VirtualAddress, sections[i].SizeOfRawData);
			VirtualProtect((DWORD)ModuleBase + sections[i].VirtualAddress, sections[i].SizeOfRawData, PAGE_EXECUTE_READWRITE, &oldProtect);
			for(j = 0; j < sections[i].SizeOfRawData; j++) {
				if(memcmp(&(((PBYTE)((DWORD)ModuleBase + sections[i].VirtualAddress))[j]), sig, sizeof(sig)) == 0) {
					printf("patching system call %X @ 0x%08X\n",
						*(PDWORD)&(((PBYTE)((DWORD)ModuleBase + sections[i].VirtualAddress))[j-4]),
						(DWORD)&(((PBYTE)((DWORD)ModuleBase + sections[i].VirtualAddress))[j]));
					((PBYTE)((DWORD)ModuleBase + sections[i].VirtualAddress))[j+4]  = 0xf;
					((PBYTE)((DWORD)ModuleBase + sections[i].VirtualAddress))[j+5]  = 0x5;
				}
			}
			VirtualProtect((DWORD)ModuleBase + sections[i].VirtualAddress, sections[i].SizeOfRawData, oldProtect, &oldProtect);
			return;
		}
	}
}

//6722895 - syscall
//7050240 - int2e
//7237539
//19963880

int main(int nargs, char **args) {
	int i;
	LARGE_INTEGER t1, t2;
	SYSTEMTIME lpSystemTime;

	//ReplaceNTDLLInterrupts();
	
	SetThreadAffinityMask(GetCurrentThread(), 1);
	SetThreadAffinityMask(GetCurrentThread(), 2);
	SetThreadAffinityMask(GetCurrentThread(), 3);
	
	QueryPerformanceCounter(&t1);
    for(i = 0; i < 10000000; i++)
		ZwGetTickCount();
	QueryPerformanceCounter(&t2);
	printf("%I64d counts\n", t2.QuadPart - t1.QuadPart);
	return 0;
}
